"use strict";

var _core = require("@babel/core");

var _helperPluginUtils = require("@babel/helper-plugin-utils");

module.exports = (0, _helperPluginUtils.declare)((api, options) => {
  api.assertVersion(7);
  const keys = Object.keys(options);
  const values = Object.values(options);
  return {
    name: 'replace-import-extensions',
    visitor: {
      ImportDeclaration(path) {
        path.traverse({
          StringLiteral(path) {
            const value = path.node.value;
            let source;
            const needReplace = keys.some((key, i) => {
              const reg = new RegExp(key);
              const matched = reg.test(value);

              if (matched) {
                source = value.replace(reg, values[i]);
              }

              return matched;
            });

            if (needReplace) {
              path.replaceWith(_core.types.StringLiteral(source));
            }
          }

        });
      }

    }
  };
});